@import (reference) '../../../less/platoreso.less';
@import (reference) '../Cards.less';

@cardHeight: 230px;

.gridBox() {
  flex-grow: 1;
  flex-basis: 300px;
  height: @cardHeight;
  margin-right: 0.5em; // In a grid we need a right margin too

  //&:not(:last-child) {
  margin-bottom: 0.5em;
  //}
}

// PHASE LAYOUT OVERRIDE
// > div is the CSSTransitionGroup
#project-board .phase.panel.grid.layout .scrollableContainer > div {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  align-content: flex-start;
  padding-right: 0.5em !important; // Cancel because cards come with their own margin
  padding-bottom: 0.5em !important; // Cancel because cards come with their own margin
  /*&:after { // Fill the rest of the space so that the last element doesn't stretch like a dumb dumb
    content: "";
    flex: auto;
    //.gridBox();
  }*/
}

.grid.card.preview {

  .gridBox();

  // Hack to get flex rows to leave enough empty space
  // We leave the same number of empty cards as there are cards to make sure we have enough
  &:empty {
    height: 0;
    margin-bottom: 0;
  }

  .cardLayout {
    display: flex;
    flex-direction: column;
    flex: 1 1 auto;
    overflow: hidden;
    height: 100%;
    //font-size: 0.875rem; // Set the base font-size, then use ems for the rest
    font-size: 1rem; // Set the base font-size, then use ems for the rest

    .content {
      display: flex;
      flex-direction: column;
      flex-grow: 1;
      padding-left: 1em;
      padding-right: 1em;
      padding-top: 1em;
      overflow: hidden; /* Chromium + Firefox seems to need this */

      .name {
        flex: 0 0 auto;
        line-height: 1.25em;
        &:not(:last-child) {
          margin-bottom: 0.25em;
        }
      }
      .body {
        position: relative;
        flex: 1 1 auto;
        font-size: 0.875em;
        line-height: 1.25em;
        overflow: hidden;
        &:not(:last-child):after {
          content: "";
          position: absolute;
          bottom: 0;
          width: 100%;
          height: 1.25em;
          background: -moz-linear-gradient(top, fade(@cardPreviewBackground, 0) 0%, fade(@cardPreviewBackground, 1) 100%); /* FF3.6-15 */
          background: -webkit-linear-gradient(top, fade(@cardPreviewBackground, 0) 0%, fade(@cardPreviewBackground, 1) 100%); /* Chrome10-25,Safari5.1-6 */
          background: linear-gradient(to bottom, fade(@cardPreviewBackground, 0) 0%, fade(@cardPreviewBackground, 1) 100%); /* W3C, IE10+, FF16+, Chrome26+, Opera12+, Safari7+ */
          filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#ffffff', endColorstr='#00ffffff', GradientType=0); /* IE6-9 */
          .snapshot:not(.linked)& {
            background: -moz-linear-gradient(top, rgba(246, 246, 246, 0) 0%, rgba(246, 246, 246, 1) 100%); /* FF3.6-15 */
            background: -webkit-linear-gradient(top, rgba(246, 246, 246, 0) 0%, rgba(246, 246, 2465, 1) 100%); /* Chrome10-25,Safari5.1-6 */
            background: linear-gradient(to bottom, rgba(246, 246, 246, 0) 0%, rgba(246, 246, 246, 1) 100%); /* W3C, IE10+, FF16+, Chrome26+, Opera12+, Safari7+ */
            filter: progid:DXImageTransform.Microsoft.gradient(startColorstr='#f6f6f6', endColorstr='#00f6f6f6', GradientType=0); /* IE6-9 */
          }
        }
        /*p:after {
          content: '\a\a';
          white-space: pre;
        }*/
      }
      .tags {
        flex: 0 1 auto;
        overflow: hidden;
        margin-top: 0.25em;
        padding-bottom: 1em;
      }
    }

    .metadata {
      flex-shrink: 0;
      padding: 0.5em;
      border-top: 1px solid rgba(0, 0, 0, 0.05);
      .profile {
        margin-right: 0.25em;
      }
      .info {
        line-height: 1em;
        .author, .created-date {
          font-size: 0.8em; // Required, otherwise the cardDetails font-size kicks in
        }
      }
      .stats {
        .stat {
          margin-right: 0.5em;
        }
      }
    }

    .cardImage {
      background-size: cover;
      background-position: center;
      background-repeat: no-repeat;
      vertical-align: middle;
    }
  }

  &.no-image {
    &.badgesIn {
      .content {
        padding-left: 3rem;
      }
    }

    &.badgesOut {
      .content {
        padding-right: 3rem;
      }
    }
  }

  &.vertical-image {
    .cardImageContainer {
      position: absolute;
      top: 0;
      left: 0;
      bottom: 0;
      width: 33%;

      &:after {
        content: '';
        position: absolute;
        top: 0;
        bottom: 0;
        right: 0;
        width: 1px;
        height: 100%;
        background-color: rgba(0, 0, 0, 0.125);
      }

      &:first-child {
        //border-radius: @cardBorderRadius 0 0 @cardBorderRadius;
      }
    }
    .cardImage {
      max-height: @cardHeight;
    }
    .content, .metadata {
      margin-left: 33%;
    }
    &.badgesOut {
      .content {
        padding-right: 3rem;
      }
    }
  }

  &.horizontal-image {
    .cardImageContainer {
      height: 96px;
      &:after {
        content: '';
        position: absolute;
        left: 0;
        right: 0;
        bottom: 0;
        width: 100%;
        height: 1px;
        background-color: rgba(0, 0, 0, 0.125);
      }
    }
    .cardImage {
      max-height: 96px;
    }
  }

}